﻿using System;
using System.Collections;

namespace Primzahlen
{
    class Program
    {
        class SiebDesEratosthenes
        {
            static void Main(string[] args)
            {
                int UpperBound = int.MaxValue;// Zahl, bis zu der gesucht werden soll, eingeben
                Console.WriteLine("Init start. Suche bis {0}", UpperBound);
                // Array zur Speicherung, ob die zum Index passende Zahl prim ist.
                BitArray primes = new BitArray(UpperBound);
                // Schätzung der Listengröße  nach Adrien-Marie Legendre
                int primeCount = (int)((double)UpperBound/ (Math.Log(UpperBound) - 1.08366));
                int[] primeList = new int[primeCount];
                // Array mit true initialisieren
                // alle sind potentiell Primzahlen
                primes.SetAll(true);
                primes.Set(0, false);

                Console.WriteLine("Markierung start.");
                // alle Zahlen bis zur Wurzel der oberen Zahl durchlaufen
                for (int i = 2; i < Math.Sqrt(UpperBound); i++)
                {
                    if (primes[i - 1])
                    {
                        for (int k = (UpperBound)/ i; k >= i; k--)
                        {
                            primes[k * i - 1] = false;
                        }
                    }
                }
                Console.WriteLine("Liste schreiben start.");
                // alle Primzahlen in eine Liste schreiben
                uint n = 0;
                for (int i = 0; i < primes.Length; i++)
                {
                    if (primes[i])
                    {
                        if (n < primeList.Length)
                        {
                            primeList[n] = i + 1;
                        }
                        n++;
                    }
                }
                // Liste ausgeben
                foreach (var item in primeList)
                {
                    if (item > 0)
                        Console.WriteLine(item.ToString());
                }
                Console.WriteLine("Anzahl {0} nach Adrien-Marie Legendre {1} ",
                    n.ToString(), primeCount);
                Console.WriteLine("fertig.");
                Console.ReadLine();
            }
        }
    }
}
